#!/bin/bash

clear
echo " --------------------------------------------"
echo " WebGrab MTD XMLTV GRABBER                   "
echo " Release v0.1.1 BETA - 2019/06/15            "
echo " --------------------------------------------"
echo ""

# ################
# INITIALIZATION #
# ################

printf "Initializing script environment..."
sleep 1s

#
# CHECK IF ALL APPLICATIONS ARE INSTALLED
#



command -v curl >/dev/null 2>&1 || { printf "\ncurl is required but it's not installed!" >&2; ERROR2="true"; }
command -v time >/dev/null 2>&1 || { printf "\ntime is required but it's not installed!" >&2; ERROR2="true"; }
command -v wget >/dev/null 2>&1 || { printf "\nwget is required but it's not installed!" >&2; ERROR2="true"; }
command -v perl >/dev/null 2>&1 || { printf "\nperl is required but it's not installed!" >&2; ERROR2="true"; }
command -v cpan >/dev/null 2>&1 || { printf "\ncpan is required but it's not installed!" >&2; ERROR2="true"; }
command -v mono >/dev/null 2>&1 || { printf "\nmono is required but it's not installed!" >&2; ERROR2="true"; }
command -v php >/dev/null 2>&1 || { printf "\nphp is required but it's not installed!" >&2; ERROR2="true"; }
command -v git >/dev/null 2>&1 || { printf "\ngit is required but it's not installed!" >&2; ERROR2="true"; }
command -v xml_split >/dev/null 2>&1 || { printf "\nxml-twig-tools is required but it's not installed!" >&2; ERROR2="true"; }

if command -v perldoc >/dev/null 2>&1
then
	perldoc -l XML::DOM >/dev/null 2>&1 || { printf "\nXML::DOM module for perl is requried but not installed!" >&2; ERROR2="true"; }
	perldoc -l utf8 >/dev/null 2>&1 || { printf "\nuft8 module for perl is requried but not installed!" >&2; ERROR2="true"; }
	else
		command -v perldoc >/dev/null 2>&1 || { printf "\nperl-doc is required but it's not installed!" >&2; ERROR2="true"; }
fi

if php -m |grep curl >/dev/null 2>&1
then
	printf "\n"
	else
		printf "\nphp-curl is required but it's not installed!" >&2; ERROR2="true";
fi


if [ ! -z "$ERROR2" ]
then
	printf "\n\n[ FATAL ERROR ] Required applications are missing - Stop.\n"
	exit 1
fi

#
# SETTING BASE PREMISSIONS
#

chmod 0777 -R *

#
# Convert Channels into Rytec Format and check Duplicated Channel IDś
#

curl -s https://raw.githubusercontent.com/DeBaschdi/EPGScripts/master/channelmapper/channelmapper_rytec.pl > mapper/channelmapper_rytec.pl
chmod 0777 mapper/channelmapper_rytec.pl
clear
perl mapper/channelmapper_rytec.pl < WebGrab++.config.xml > xml/WebGrab++.config.xml
sleep 3s
cat xml/WebGrab++.config.xml | grep 'xmltv_id=' | sed 's#^.*xmltv_id="##' |sed -r 's/([^\.]*)\".*/\1/' >chlist
sort chlist | uniq -d > xml/duplicates

if [ -s xml/duplicates ]
	then
		clear
		echo "-------ERROR-------"
		echo ""
		echo "Duplicated Channel IDs exist in this setup!"
		echo "Please remove the duplicated entries from setup"
		echo "List of duplicated Channel IDs :"
		echo ""
		echo "$(<xml/duplicates)"
		echo ""
		exit
	else
		clear
		rm xml/duplicates
fi


#
# CREATE 8 WG++ Tasks in /tmp
#

mkdir /tmp/w1 2> /dev/null
mkdir /tmp/w2 2> /dev/null
mkdir /tmp/w3 2> /dev/null
mkdir /tmp/w4 2> /dev/null
mkdir /tmp/w5 2> /dev/null
mkdir /tmp/w6 2> /dev/null
mkdir /tmp/w7 2> /dev/null
mkdir /tmp/w8 2> /dev/null
cp -R wg++/* /tmp/w1 2> /dev/null
cp -R wg++/* /tmp/w2 2> /dev/null
cp -R wg++/* /tmp/w3 2> /dev/null
cp -R wg++/* /tmp/w4 2> /dev/null
cp -R wg++/* /tmp/w5 2> /dev/null
cp -R wg++/* /tmp/w6 2> /dev/null
cp -R wg++/* /tmp/w7 2> /dev/null
cp -R wg++/* /tmp/w8 2> /dev/null

#
# SPLIT WebGrab++.config.xml in 8 Parts
#

config=xml/WebGrab++.config.xml
configsize=$(stat -c %s xml/WebGrab++.config.xml)

splitfiles=8
splitsize=$(expr $configsize / $splitfiles) 

sed -i '/<filename>/d' xml/WebGrab++.config.xml
sed -i '/<mode>/d' xml/WebGrab++.config.xml
sed -i '/<postprocess/d' xml/WebGrab++.config.xml
sed -i '/<user-agent>/d' xml/WebGrab++.config.xml
sed -i '/<logging>/d' xml/WebGrab++.config.xml
sed -i '/<retry/d' xml/WebGrab++.config.xml
sed -i '/<timespan>/d' xml/WebGrab++.config.xml
sed -i '/<update>/d' xml/WebGrab++.config.xml

xml_split -s $splitsize xml/WebGrab++.config.xml

#
# MODIFY SPLITTED FILES, SO WG+ CAN USE IT
#

sed -i '/xml_split/d' xml/WebGrab++.config-01.xml
sed -i '/xml_split/d' xml/WebGrab++.config-02.xml
sed -i '/xml_split/d' xml/WebGrab++.config-03.xml
sed -i '/xml_split/d' xml/WebGrab++.config-04.xml
sed -i '/xml_split/d' xml/WebGrab++.config-05.xml
sed -i '/xml_split/d' xml/WebGrab++.config-06.xml
sed -i '/xml_split/d' xml/WebGrab++.config-07.xml
sed -i '/xml_split/d' xml/WebGrab++.config-08.xml
sed -i '/settings/d' xml/WebGrab++.config-08.xml

sed  '/<channel/d' WebGrab++.config.xml > xml/WebGrab++.config.xml
sed -i '/<\/settings>/d' xml/WebGrab++.config.xml
sed -i '/^\s*$/d' xml/WebGrab++.config.xml

#
# CREATE CONFIGS FOR 8 WG THREADS
#

cat xml/WebGrab++.config.xml > /tmp/w1/WebGrab++.config.xml
echo '' >> /tmp/w1/WebGrab++.config.xml
cat xml/WebGrab++.config-01.xml >> /tmp/w1/WebGrab++.config.xml
echo '' >> /tmp/w1/WebGrab++.config.xml
echo '</settings>' >> /tmp/w1/WebGrab++.config.xml

cat xml/WebGrab++.config.xml > /tmp/w2/WebGrab++.config.xml
echo '' >> /tmp/w2/WebGrab++.config.xml
cat xml/WebGrab++.config-02.xml >> /tmp/w2/WebGrab++.config.xml
echo '' >> /tmp/w2/WebGrab++.config.xml
echo '</settings>' >> /tmp/w2/WebGrab++.config.xml

cat xml/WebGrab++.config.xml > /tmp/w3/WebGrab++.config.xml
echo '' >> /tmp/w3/WebGrab++.config.xml
cat xml/WebGrab++.config-03.xml >> /tmp/w3/WebGrab++.config.xml
echo '' >> /tmp/w3/WebGrab++.config.xml
echo '</settings>' >> /tmp/w3/WebGrab++.config.xml

cat xml/WebGrab++.config.xml > /tmp/w4/WebGrab++.config.xml
echo '' >> /tmp/w4/WebGrab++.config.xml
cat xml/WebGrab++.config-04.xml >> /tmp/w4/WebGrab++.config.xml
echo '' >> /tmp/w4/WebGrab++.config.xml
echo '</settings>' >> /tmp/w4/WebGrab++.config.xml

cat xml/WebGrab++.config.xml > /tmp/w5/WebGrab++.config.xml
echo '' >> /tmp/w5/WebGrab++.config.xml
cat xml/WebGrab++.config-05.xml >> /tmp/w5/WebGrab++.config.xml
echo '' >> /tmp/w5/WebGrab++.config.xml
echo '</settings>' >> /tmp/w5/WebGrab++.config.xml

cat xml/WebGrab++.config.xml > /tmp/w6/WebGrab++.config.xml
echo '' >> /tmp/w6/WebGrab++.config.xml
cat xml/WebGrab++.config-06.xml >> /tmp/w6/WebGrab++.config.xml
echo '' >> /tmp/w6/WebGrab++.config.xml
echo '</settings>' >> /tmp/w6/WebGrab++.config.xml

cat xml/WebGrab++.config.xml > /tmp/w7/WebGrab++.config.xml
echo '' >> /tmp/w7/WebGrab++.config.xml
cat xml/WebGrab++.config-07.xml >> /tmp/w7/WebGrab++.config.xml
echo '' >> /tmp/w7/WebGrab++.config.xml
echo '</settings>' >> /tmp/w7/WebGrab++.config.xml

cat xml/WebGrab++.config.xml > /tmp/w8/WebGrab++.config.xml
echo '' >> /tmp/w8/WebGrab++.config.xml
cat xml/WebGrab++.config-08.xml >> /tmp/w8/WebGrab++.config.xml
echo '' >> /tmp/w8/WebGrab++.config.xml
echo '</settings>' >> /tmp/w8/WebGrab++.config.xml

#
# SETTING PREMISSIONS IN TMP DIR
#

chmod 0777 -R /tmp/w1 & chmod 0777 -R /tmp/w2 & chmod 0777 -R /tmp/w3 & chmod 0777 -R /tmp/w4 & chmod 0777 -R /tmp/w5 & chmod 0777 -R /tmp/w6 & chmod 0777 -R /tmp/w7 & chmod 0777 -R /tmp/w8

#
# STARTING PROXY SERVER FOR WG++
#

server/server.sh &
serverpid=$(ps | grep php | cut -b 1-5)

#
# STARTING DOWNLOAD
#

/tmp/w1/run.sh & /tmp/w2/run.sh & /tmp/w3/run.sh & /tmp/w4/run.sh & /tmp/w5/run.sh & /tmp/w6/run.sh & /tmp/w7/run.sh & /tmp/w8/run.sh

function wait_for_wgplus { 
        thread=$(ps ax)
        if [[ $thread =~ ^.*WebGrab.*$ ]] ;
        then sleep 5 ;
        wait_for_wgplus ;
        fi
        }

wait_for_wgplus

#
# STOP PROXY SERVER
#

kill -9 $serverpid

#
# MERGE GUIDES TOGETHER
#

./merge-t8.sh

function wait_for_merge { 
        thread=$(ps ax)
        if [[ $thread =~ ^.*WebGrab.*$ ]] ;
        then sleep 5 ;
        wait_for_merge ;
        fi
        }

wait_for_merge

#
# MAP GENRE INTO EIT
#

curl -s https://raw.githubusercontent.com/DeBaschdi/EPGScripts/master/genremapper/genremapper.pl > mapper/genremapper.pl
chmod 0777 mapper/genremapper.pl
perl mapper/genremapper.pl < xml/guide.xml > xml/guide-mapped.xml

#
# RUN IMDBMAPPER
#

curl -s https://raw.githubusercontent.com/DeBaschdi/EPGScripts/master/new_imdbmapper/Readme > imdb/Readme
curl -s https://raw.githubusercontent.com/DeBaschdi/EPGScripts/master/new_imdbmapper/age.php > imdb/age.php
curl -s https://raw.githubusercontent.com/DeBaschdi/EPGScripts/master/new_imdbmapper/country.php > imdb/country.php
curl -s https://raw.githubusercontent.com/DeBaschdi/EPGScripts/master/new_imdbmapper/imdb.class.php > imdb/imdb.class.php
curl -s https://raw.githubusercontent.com/DeBaschdi/EPGScripts/master/new_imdbmapper/run.pl > imdb/run.pl
curl -s https://raw.githubusercontent.com/DeBaschdi/EPGScripts/master/new_imdbmapper/poster.php > imdb/poster.php
curl -s https://raw.githubusercontent.com/DeBaschdi/EPGScripts/master/new_imdbmapper/rating.php > imdb/rating.php
curl -s https://raw.githubusercontent.com/DeBaschdi/EPGScripts/master/new_imdbmapper/url.php > imdb/url.php
curl -s https://raw.githubusercontent.com/DeBaschdi/EPGScripts/master/new_imdbmapper/year.php > imdb/year.php
curl -s https://raw.githubusercontent.com/DeBaschdi/EPGScripts/master/new_imdbmapper/imdbtask.pl > imdb/imdbtask.pl
curl -s https://raw.githubusercontent.com/DeBaschdi/EPGScripts/master/new_imdbmapper/worker1.pl > imdb/worker1.pl
curl -s https://raw.githubusercontent.com/DeBaschdi/EPGScripts/master/new_imdbmapper/worker2.pl > imdb/worker2.pl
curl -s https://raw.githubusercontent.com/DeBaschdi/EPGScripts/master/new_imdbmapper/prozes.pl > imdb/prozes.pl
curl -s https://raw.githubusercontent.com/DeBaschdi/EPGScripts/master/new_imdbmapper/bar.sh > imdb/bar.sh
chmod 0777 -R imdb/*
perl imdb/run.pl xml/guide-mapped.xml xml/guide-imdb.xml

# 
# RUN RATING MAPPER
#

function wait_for_imdb { 
        thread=$(ps ax)
        if [[ $thread =~ ^.*imdbtask.*$ ]] ;
        then sleep 5 ;
        wait_for_imdb ;
        fi
        }

wait_for_imdb

imdb/status.sh destroy_scroll_area

curl -s https://raw.githubusercontent.com/DeBaschdi/EPGScripts/master/ratingmapper/ratingmapper.pl > mapper/ratingmapper.pl
chmod 0777 mapper/ratingmapper.pl
perl mapper/ratingmapper.pl xml/guide-imdb.xml > guide-finish.xml
chmod 0777 guide-finish.xml

#
# CLEAN XML FOLDER
#

rm xml/*

exit
